import java.util.*;
import java.io.*;



public class chisquared
{
	ArrayList<cluster> clusters;
	ArrayList<HashMap<String,Double>> FinalValues;

	public chisquared()
	{
		String FileName = "10000 photos";
		int amountofclusters = 100;


		clusters = ReadSample(amountofclusters);

		System.out.println(clusters.get(0).getPhotos().get(0).getTags());


		GetUniqueTags(clusters);

		CountUniqueTags(clusters);


		System.out.println(clusters.get(1).getUniqueTags());


		HashMap<String, Integer> TotalVocab = GetVocab(clusters);



		int TotalTagOccurrences = 0;
		for (String S : TotalVocab.keySet())
		{
			TotalTagOccurrences += TotalVocab.get(S);
		}

		System.out.println(TotalTagOccurrences);

		FinalValues = DoMaths(clusters, TotalVocab, TotalTagOccurrences);


		OutputValues(FinalValues, FileName);





	}

	public static void main(String[] args)
	{
		new chisquared();

	}




	public ArrayList<cluster> ReadSample(int howManyClusters)
	{

		ArrayList<cluster> ClustersOfPhotos = new ArrayList<cluster>();

		for(int i = 0; i < howManyClusters;i++)
		{

			cluster Cluster = new cluster();

			//Get photo count for each cluster
			File file = new File("E:/Samples/ClustersFor10023 Photos/Cluster Amount" + howManyClusters + "cluster" + i + ".tra");
			BufferedReader reader = null;
			int Count = 0;

			try
			{
				reader = new BufferedReader(new FileReader(file));
				String currentLine;
				//repeat until all lines are read
				while ((currentLine = reader.readLine()) != null)
				{

					String[] s = currentLine.split("\t");
					String[] T = s[2].split(",");


					photo p = new photo(T);
					Count++;
					Cluster.addphoto(p);

				}
			}
			catch (FileNotFoundException e)
			{
				e.printStackTrace();
			}
			catch (IOException e)
			{
				e.printStackTrace();
			}
			finally
			{
				try
				{
					if (reader != null)
					{
						reader.close();
					}
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
		ClustersOfPhotos.add(Cluster);
		}
		return ClustersOfPhotos;
	}


	public void GetUniqueTags(ArrayList<cluster> clusters)
	{
		for(cluster c : clusters)
		{
			c.computeUniqueTags();
		}
	}

	public void CountUniqueTags(ArrayList<cluster> clusters)
	{
		for(cluster c : clusters)
		{
			c.countUniqueTags();
		}
	}

	public HashMap<String, Integer> GetVocab(ArrayList<cluster> clusters)
	{
		HashMap<String, Integer> TotalVocab = new HashMap<String,Integer>();
		for (cluster c : clusters)
		{
			for (String S : c.getUniqueTags().keySet())
			{
				if(TotalVocab.get(S)==null)
				{
					TotalVocab.put(S,0);
				}
				int temp = TotalVocab.get(S);
				temp++;
				TotalVocab.put(S,temp);

			}
		}
		return TotalVocab;
	}


	public ArrayList<HashMap<String,Double>> DoMaths(ArrayList<cluster> clusters, HashMap<String,Integer> TotalVocab, int TotalTagOccurrences)
	{

		//TOTALPHOTOS
		int TOTALPHOTOS = 0;
		for(cluster c : clusters)
		{
			TOTALPHOTOS += c.AmountOfPhotos();
		}

		//Chi Squared value for each tag in each cluster
		ArrayList<HashMap<String,Double>> ClusterChiValues = new ArrayList<HashMap<String,Double>>();
		for(cluster c : clusters)
		{
			HashMap<String,Double> ChiValues = new HashMap<String,Double>();
			for (String S : c.getUniqueTags().keySet())
			{
				//could be 1+
				int OccurInCluster = c.getUniqueTags().get(S);

				//could be 0
				int OccurOutCluster = 0;
				for (cluster m : clusters)
				{
					if(c==m)
					{
						continue;
					}

					Integer count = m.getUniqueTags().get(S);
					if(count!=null)
					{
						OccurOutCluster += count;
					}
				}

				int NotOccurInCluster = 0;
				for (photo p : c.getPhotos())
				{
					if(! p.doesExist(S))
					{
						NotOccurInCluster ++;
					}
				}

				int NotOccurOutCluster = 0;
				for (cluster m : clusters)
				{
					if(c==m)
					{
						continue;
					}


					for (photo p : m.getPhotos())
					{
						if(! p.doesExist(S))
						{
							NotOccurOutCluster ++;
						}
					}

				}

				//Work Out P(t) and P(a)

				//P(t)

				int AllOccurances = OccurInCluster + OccurOutCluster;
				double Pt = AllOccurances / (double) TotalTagOccurrences;

				//P(a)

				double Pa = c.getPhotos().size() / (double)TOTALPHOTOS;

				double ETA1 = TOTALPHOTOS * Pt * Pa;
				double ETA2 = TOTALPHOTOS * Pt * (1-Pa);
				double ETA3 = TOTALPHOTOS * (1-Pt) * Pa;
				double ETA4 = TOTALPHOTOS * (1-Pt) * (1-Pa);

				//Get Figure
				double F1 = ((OccurInCluster - ETA2) * (OccurInCluster - ETA2)) / ETA2;
				double F2 = ((OccurOutCluster - ETA2) * (OccurOutCluster - ETA2)) / ETA2;
				double F3 = ((NotOccurInCluster - ETA3) * (NotOccurInCluster - ETA3)) / ETA3;
				double F4 = ((NotOccurOutCluster - ETA4) * (NotOccurOutCluster - ETA4)) / ETA4;

				double figure = F1 + F2 + F3 + F4;

				ChiValues.put(S,figure);

			}

			ClusterChiValues.add(ChiValues);

		}

		return ClusterChiValues;
	}

	public void OutputValues(ArrayList<HashMap<String,Double>> FinalValues, String FileName)
	{
		int filecount = 0;
		for (HashMap<String,Double> H : FinalValues)
		{
			try
			{
				//Create Directory
				File dir = new File("E:/Samples/ChiValuesFor" + FileName);
				dir.mkdir();
				// Create file
				FileWriter fstream = new FileWriter("E:/Samples/ChiValuesFor" + FileName + "/" + "Cluster Amount" + filecount,true);
				BufferedWriter out = new BufferedWriter(fstream);
				for (String S : H.keySet())
				{
					out.write(S + "," + H.get(S));
					out.write("\r\n");
				}
				out.close();
			}
			catch (Exception e)
			{
			//Catch exception if any
			System.err.println("Error: " + e.getMessage());
			}
			filecount++;
		}
	}
}





class photo
{
	private ArrayList<String> tags;

	public photo(String[] inputTags)
	{
		this.tags = new ArrayList<String>();

		for(int i = 0;i<inputTags.length;i++)
		{
			tags.add(inputTags[i]);
		}

	}

	public photo()
	{
	}

	public ArrayList<String> getTags()
	{
		return this.tags;
	}


	public boolean doesExist(String s)
	{
		return this.tags.contains(s);
	}


}




class cluster
{

	private ArrayList<photo> photos = new ArrayList<photo>();
	private HashMap<String, Integer> UniqueTags = new HashMap<String, Integer>();

	public cluster()
	{

	}

	public void computeUniqueTags()
	{
		for (photo p : photos)
		{
			for (String T : p.getTags())
			{
				UniqueTags.put(T,0);
			}
		}
	}

	public void countUniqueTags()
	{
		for(String s : UniqueTags.keySet())
		{
			for(photo p : photos)
			{
				if(p.doesExist(s))
				{
					int i = UniqueTags.get(s);
					i++;
					UniqueTags.put(s,i);
				}
			}
		}
	}


	public void addphoto(photo p)
	{
		this.photos.add(p);
	}

	public ArrayList<photo> getPhotos()
	{
		return this.photos;
	}

	public HashMap<String, Integer> getUniqueTags()
	{
		return this.UniqueTags;
	}

	public int AmountOfPhotos()
	{
		return this.photos.size();
	}


}